unit OXFProp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TCFGProp = class(TForm)
    NameEdit: TEdit;
    PathEdit: TEdit;
    MacroBtn: TButton;
    Label1: TLabel;
    Label2: TLabel;
    BrowseBtn: TButton;
    OKBtn: TButton;
    CancelBtn: TButton;
    MacrosListBox: TListBox;
    MacroLbl: TLabel;
    procedure MacrosListBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure MacroBtnClick(Sender: TObject);
    procedure MacrosListBoxDblClick(Sender: TObject);
  private
    Function GetPathName: String;
    Function GetPath: String;
    Procedure SetPathName(Const Value: String);
    Procedure SetPath(Const Value: String);
  public
    Property PathName: String Read GetPathName write SetPathName;
    Property Path: String Read GetPath write SetPath;
  end;

var
  CFGProp: TCFGProp;

implementation
Uses OXMacro;

{$R *.DFM}

Function TCFGProp.GetPathName: String;
begin
  Result := NameEdit.Text;
end;

Function TCFGProp.GetPath: String;
begin
  Result := PathEdit.Text;
end;
Procedure TCFGProp.SetPathName(Const Value: String);
begin
  NameEdit.Text := Value;
end;
Procedure TCFGProp.SetPath(Const Value: String);
begin
  PathEdit.Text := Value;
end;
procedure TCFGProp.MacrosListBoxDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
const
  TabStr: Pchar = #9;
Var
 Col1,
 Col2: TRect;
 PText: PChar;
 TabPos: PChar;
begin
  With Control as TListBox do
    begin
      Canvas.FillRect(Rect);
      Col1.TopLeft := Rect.TopLeft;
      Col1.Bottom := Rect.Bottom;
      If Rect.Right > 120 then
        Col1.Right := 120
      else
        Col1.Right := Rect.Right;
      Col2.Top := Rect.Top;
      Col2.Left := Col1.Right + 5;
      Col2.BottomRight := Rect.BottomRight;
      PText := PChar(Items[Index]);
      TabPos := StrPos(PText,TabStr);
      If TabPos <> nil then
        begin {Draw the second part}
          TabPos^ := #0; {Terminate the first PChar}
          repeat
            INC(TabPos); {Go past the tabs}
          until (TabPos^ = #0) or (TabPos^ <> TabStr);
          DrawText(Canvas.Handle, TabPos, -1, Col2, DT_SINGLELINE);
        end;
      DrawText(Canvas.Handle, PText, -1, Col1, DT_SINGLELINE);
    end;
end;

procedure TCFGProp.MacroBtnClick(Sender: TObject);
var
  Down: Boolean;
begin
  Down := MacroLbl.Visible;
  Macrolbl.Visible := Not Down;
  MacrosListBox.Visible := Not Down;
  if Down Then
    ClientHeight := OkBtn.Top + OKBtn.Height + 5
  else
    ClientHeight := OkBtn.Top + OKBtn.Height + 5 + MacrosListBox.Height;
end;

procedure TCFGProp.MacrosListBoxDblClick(Sender: TObject);
begin
  If MacrosListBox.Itemindex > -1 then
    begin
      PathEdit.Text := PathEdit.Text +
        '<' + Macros[MacrosListBox.ItemIndex] + '>';
    end;
end;

end.
